Attribute VB_Name = "ExifLib"
Option Explicit
Type Exif_Header
  head As String * 4
  reserved(1) As Byte
End Type

Type TIFF_Header
  Endian As Integer
  tag As Integer
  IFD_Offset As Long
End Type

Type Exif_Entry
  tag As Integer
  dformat As Integer
  number As Long
  data As Long
End Type

Function BEInt(ByVal i As Integer, Optional b As Boolean = True) As Integer
'Integer̃GfBAϊ
Dim l As Long

If b Then

  l = i
  l = ((i And &HFF&) * 256) Or ((i And &HFF00&) \ 256)
  
  BEInt = CInt(l And &H7FFF)
  If (l And &H8000) <> 0 Then BEInt = BEInt Or &H8000
Else
  BEInt = i
End If


End Function

Function BELong(ByVal l As Long, Optional b As Boolean = True) As Long
'Integer̃GfBAϊ

If b Then
  BELong = (((l And &HFF000000) \ &H1000000) And &HFF) Or _
  (((l And &HFF0000) \ &H100) And &HFF00&) Or _
  (((l And &HFF00&) * &H100) And &HFF0000) Or _
  (((l And &H7F&) * &H1000000) And &H7F0000)
  If (l And &H80) <> 0 Then BELong = BELong Or &H80000000

Else
  BELong = l
End If

End Function

Function AnalyzeEXIF(fn As String) As Date
Dim fnum&, i&
Dim di As Integer, l&
Dim tiff As TIFF_Header
Dim ExifLen%, EH As Exif_Header
Dim PosStart&
Dim Endian As Boolean
Dim nentry%
Dim Entries() As Exif_Entry
Dim pos&, ExifIFDPos&
Dim DateTime$
On Error Resume Next

'ĂяodirĂ
'fn = Dir(fn)
'If fn = "" Then Exit Function

fnum = FreeFile

Open fn For Binary As fnum
Get #fnum, , di
'Debug.Print "SOI - " + Hex(di)
Get #fnum, , di
If di <> &HE1FF Then GoTo endfile
Get #fnum, , ExifLen
'Debug.Print "Exif - " + Hex(di) + " len=" + CStr(BEInt(ExifLen))
Get #fnum, , EH
'Debug.Print "header - " + EH.head

PosStart = Seek(fnum)
Get #fnum, , tiff
'Debug.Print "tiff - " + Hex(tiff.Endian) + " " + Hex(tiff.tag) + " " + Hex(tiff.IFD_Offset)

Endian = (tiff.Endian = &H4D4D)

Get #fnum, , nentry
nentry = BEInt(nentry, Endian)
'Debug.Print "Entries=" + CStr(nentry)

If nentry > 0 Then
  ReDim Entries(nentry - 1) As Exif_Entry
  Get #fnum, , Entries
  For i = 0 To nentry - 1
    With Entries(i)
        
      'Debug.Print "Entry[" + CStr(i) + "] : tag : 0x" + Hex(BEInt(.tag, Endian))
      If BEInt(.tag, Endian) = &H132 Then
        't!
        pos = PosStart + BELong(.data, Endian)
        Seek #fnum, pos
        DateTime = Trim(StrConv(InputB(19, fnum), vbUnicode))
        GoTo endfile
      ElseIf BEInt(.tag, Endian) = &H8769 Then
        ExifIFDPos = PosStart + BELong(.data, Endian)
      End If
    End With
  Next
End If
  
If ExifIFDPos > 0 Then
  Seek #fnum, ExifIFDPos
  
  Get #fnum, , nentry
  nentry = BEInt(nentry, Endian)
  'Debug.Print "Entries=" + CStr(nentry)
  
  If nentry > 0 Then
    ReDim Entries(nentry - 1) As Exif_Entry
    Get #fnum, , Entries
    For i = 0 To nentry - 1
      With Entries(i)
          
        'Debug.Print "Entry[" + CStr(i) + "] : tag : 0x" + Hex(BEInt(.tag, Endian))
        If BEInt(.tag, Endian) = &H9003 Then
          't!
          pos = PosStart + BELong(.data, Endian)
          Seek #fnum, pos
          DateTime = Trim(StrConv(InputB(19, fnum), vbUnicode))
          GoTo endfile
        End If
      End With
    Next
  End If
End If


endfile:
Close fnum

If Len(DateTime) > 8 Then
  Mid(DateTime, 5, 1) = "/"
  Mid(DateTime, 8, 1) = "/"
  
  AnalyzeEXIF = (CDate(DateTime))
End If
End Function


